<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Thuongnh</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="../plugins/fontawesome-free/css/all.min.css">
  <!-- daterange picker -->
  <link rel="stylesheet" href="../plugins/daterangepicker/daterangepicker.css">
  <!-- Bootstrap Color Picker -->
  <link rel="stylesheet" href="../plugins/bootstrap-colorpicker/css/bootstrap-colorpicker.min.css">
  <!-- Tempusdominus Bootstrap 4 -->
  <link rel="stylesheet" href="../plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
  <!-- font-awesome -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="../dist/css/adminlte.min.css">
  <!-- Select2 -->
  <link rel="stylesheet" href="../plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="../plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <!-- data table -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.3/css/dataTables.bootstrap4.min.css">
</head>

<body class="hold-transition sidebar-mini">
  <!-- Site wrapper -->
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="../index3.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="../dist/img/user1-128x128.jpg" alt="user Avatar" class="img-size-50 mr-3 img-circle">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="../dist/img/user8-128x128.jpg" alt="user Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="../dist/img/user3-128x128.jpg" alt="user Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="control-sidebar" data-slide="true" href="#" role="button">
            <i class="fas fa-th-large"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="../index3.html" class="brand-link">
        <img src="../dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">AdminLTE 3</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="../dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="user Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">NGUYỄN HỮU THƯƠNG</a> 
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <!-- 1 -->
                <li class="nav-item">
                  <a href="./VoucherCRUD.html" class="nav-link ">
                    <i class="far fa-circle nav-icon"></i>
                    <p>VOUCHER CRUD</p>
                  </a>
                </li>
                <!-- 2 -->
                <li class="nav-item">
                  <a href="./CMENU.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>CMENU CRUD </p>
                  </a>
                </li>
                 <!-- 3 -->
                <li class="nav-item">
                  <a href="./DRINK.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>DRINK CRUD</p>
                  </a>
                </li>
                 <!-- 4 -->
                <li class="nav-item">
                  <a href="./COUNTRY.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>COUNTRY CRUD</p>
                  </a>
                </li>
                 <!-- 5 -->
                <li class="nav-item">
                  <a href="./REGION.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>REGION CRUD</p>
                  </a>
                </li>
                 <!-- 6 -->
                <li class="nav-item">
                  <a href="./USER.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>USER CRUD</p>
                  </a>
                </li>
                 <!-- 7 -->
                <li class="nav-item">
                  <a href="./ORDER.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>ORDER CRUD</p>
                  </a>
                </li>
                 <!-- 8 -->
                <li class="nav-item">
                  <a href="./PRIZE.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>PRIZE CRUD</p>
                  </a>
                </li>
                 <!-- 9 -->
                <li class="nav-item">
                  <a href="./HISTORY.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p> HISTORY CRUD</p>
                  </a>
                </li>

              </ul>
        </nav>
        <!-- /.sidebar-menu  -->
      </div>
      <!-- /.sidebar -->
    </aside>
    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">

      <!-- Main content -->
      <section class="content">
        <!-- Main content -->
        <!-- Main content -->
        <!-- Main content -->
        <div class="comtainer-fluid">
          <h1 class="text-center" style="background-color: white;">QUẢN LÝ MENU</h1>
        </div>
        <div class="comtainer-fluid">
          <div class="container">
          
            

            <div class="row">
              <div class="col-sm-2">
                <button id="btn-them-menu" class=" btn btn-success ">
                  <i class="fa-solid fa-plus"></i> Thêm
                </button>
              </div>
            </div>
          </div>
        </div>
        <!-- data table -->
        <div class="comtainer-fluid mt-5">
          <table id="table-lich-su-hoc-tap" class="table table-striped table-hover table-bordered">
            <thead>
              <tr>
                <th>STT</th>
                <th>Combo</th>
                <th>Đường kính</th>
                <th>Sườn nướng</th>
                <th>Salad</th>
                <th>Nước ngọt</th>
                <th>Thành tiền</th>
                <th>Action</th>
              </tr>
            </thead>
          </table>

        </div>
        <!-- Date -->
        <!-- Main content -->
        <!-- Main content -->
        <!-- Main content -->
      </section>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    <footer class="main-footer">
      <div class="float-right d-none d-sm-block">
        <b>Version</b> 3.2.0
      </div>
      <strong>Copyright &copy; 2014-2023 <a href="https://adminlte.io">Devcamp.io</a>.</strong> All rights reserved.
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->
  <!-- modal -->
  <!-- Update menu modal (sửa menu) -->
  <div>
    <div id="update-menu-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Chi tiết menu </h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="jumbotron container">
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-combo-update">Combo</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-combo-update" name="combo" placeholder="combo name" class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-size-update">Đường kính</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-size-update" name="duong-kinh" placeholder="Đường kính" class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-suon-update">Sườn nướng</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-suon-update" name="suon-nuong" placeholder="Sường nướng" class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-salad-update">Salad</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-salad-update" name="salad" placeholder="Salad" class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-drink-update">Nước ngọt</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-drink-update" name="nuoc-ngot" placeholder="Số lượng nước uống"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-price-update">Thành tiền</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-price-update" name="price" placeholder="Thành tiền" class="form-control">
                  </div>
                </div>
              </div>
            
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-primary" id="btn-modal-update-menu">Update menu</button>
            <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Hủy bỏ</button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Delete confirm modal -->
  <div>
    <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Confirm xóa </h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa menu này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete-menu">Xác nhận</button>
            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ </button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- insert modal (thêm menu) -->
  <div>
    <div id="insert-sinh-vien-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Tạo mới menu </h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="jumbotron container">
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-combo">Combo</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="text" id="input-combo" name="combo" placeholder="combo name" class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-size">Đường kính</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-size" name="duong-kinh" placeholder="Đường kính" class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-suon">Sườn nướng</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-suon" name="suon-nuong" placeholder="Sường nướng" class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-salad">Salad</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-salad" name="salad" placeholder="Salad" class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="input-drink">Nước ngọt</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-drink" name="nuoc-ngot" placeholder="Số lượng nước uống"
                      class="form-control">
                  </div>
                </div>
                <div class="row form-group">
                  <div class="col-sm-3">
                    <label for="price">Thành tiền</label>
                  </div>
                  <div class="col-sm-9">
                    <input type="number" id="input-price" name="price" placeholder="Thành tiền" class="form-control">
                  </div>
                </div>
              </div>

            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-primary" id="btn-modal-insert-menu">Thêm Menu</button>
            <button class="btn btn-secondary" id="btn-update-cancel-them" data-dismiss="modal">Hủy bỏ</button>

          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- .modal -->

  <!-- jQuery -->
  <script src="../plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="../plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- Select2 -->
  <script src="../plugins/select2/js/select2.full.min.js"></script>
  <!-- InputMask -->
  <script src="../plugins/moment/moment.min.js"></script>
  <script src="../plugins/inputmask/jquery.inputmask.min.js"></script>
  <!-- date-range-picker -->
  <script src="../plugins/daterangepicker/daterangepicker.js"></script>
  <!-- bootstrap color picker -->
  <script src="../plugins/bootstrap-colorpicker/js/bootstrap-colorpicker.min.js"></script>
  <!-- Tempusdominus Bootstrap 4 -->
  <script src="../plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="../dist/js/adminlte.min.js"></script>
  <!-- AdminLTE for demo purposes -->
  <script src="../dist/js/demo.js"></script>
  <!-- data table -->
  <script src="https://cdn.datatables.net/1.13.3/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.3/js/dataTables.bootstrap4.min.js"></script>

  <script>

    "use strict"

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL_MENU = "http://localhost:8080/cmenu/";
    var gId = "";
    var gStt = 0;  // khai báo số thứ tự ban đầu bằng 0;  tự reset sau mỗi lần đổ dữ liệu

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading();
      // khai báo nút sửa 
      $("#table-lich-su-hoc-tap").on("click", ".btn-edits", onSuaClick); // khai báo nút sửa   
      $("#table-lich-su-hoc-tap").on("click", ".btn-deletes", onXoaClick); // khai báo nút xóa
      $("#btn-them-menu").on("click", onAddmenuClick); // khai báo nút thêm menu 
      $("#btn-modal-insert-menu").on("click", onInsertmenuClick);   // nút xác nhận thêm  
      $("#btn-modal-update-menu").on("click", onModalUpdateMenuClick);  // khao báo chấp nhận update menu
      $("#btn-confirm-delete-menu").on("click", onConfirmDeletemenuClick);     // khai báo nút xác nhận xóa
      

    });
 
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      "use strict"
      console.log("đã load xong thẻ body ");
      // phần đổ dữ liệu cho ô select . gán dữ liệu vào biến toàn cục
      // load data table jquery nhưng chưa truyền dữ liệu 
      khoiTaoDataTable();
      //b1 bỏ qua
      //b2 bỏ qua
      //b3  call api && //b4 load data in table 
      callApiListmenu(getInsertRowTable);
    }

    // khai báo sự kiện nút sửa 
    function onSuaClick() {
      console.log("ấn nút sửa ");
      $("#update-menu-modal").modal("show");  // hiện modal
      var vObject = readObjectRow(this);
      console.log("id là:  " + vObject.id);
      gId = vObject.id;
    
      // b1 b2 bỏ qua
      // b3 . gọi api lấy object  
      var vObjectDatamenu = null;
      getDataByID(vObject.id, function (pamramRes) {
        // b4 xử lý hiển thị  đổ dữ liệu lên modal 
        console.log("pamramRes",pamramRes);
        xoaTrangUpdateMenu();
        loadDataInModalUpdatemenu(pamramRes);
        
        return;
      });
    }
    // khai báo sự kiện nút xóa menu  
    function onXoaClick() {
      console.log("ấn nut xóa ");
      var vObject = readObjectRow(this);
      console.log("id là:  " + vObject.id);
      gId = vObject.id; // 
      $("#delete-confirm-modal").modal("show");  // hiện modal xóa 
    }



    // khai báo sự kiện nút thêm menu
    function onAddmenuClick() {
      console.log("ấn nut add menu ");
      $("#insert-sinh-vien-modal").modal("show");  // hiện modal.
    }
    // khai báo nút insert menu (add menu);
    function onInsertmenuClick() {
      console.log("ấn nút insert menu ");
      //04 bước xử lý sự kiện có gọi server
      // b1 thu thâpj dữ liệu
      var vObject = readDataModalInsertmenu();  // đọc dữ liệu trên form modal sửa thông tin menu
      // b2 validate data
      var vResult = validateDataInsertmenu(vObject);
      console.log("thêm menu ", vObject);
      // b3 call server
      if (vResult) {
        $.ajax({
          type: "POST",
          url: gBASE_URL_MENU + "create" ,   
          data: JSON.stringify(vObject),
          contentType: "application/json",
          success: function (data) {
            console.log("đã thêm menu thành công");
            alert("Thêm menu thành công Id của bạn là  " + data.id);
            $("#insert-sinh-vien-modal").modal("hide"); //tắt Modal 
            callApiListmenu(getInsertRowTable); //  load lại bảng danh sách menus
            resertCreatemenuForm(); // xóa trắng dữ liệu 
          },
          error: function (e) {
            console.log(e, e.status, e.message);
            if (e.status == 422) {
              alert("lỗi trùng tên Commbo:   " + e.responseText);
              return;
            }
            alert("quá trình thêm menu gặp sự cố");
          }
        });
      }
      // b4
      console.log(vObject);
    }

    // khai baos nút xác nhận update  sửa menu
    function onModalUpdateMenuClick() {
      console.log("ấn nut xác nhận update  menu ");
      //04 bước xử lý sự kiện có gọi server
      // b1 thu thâpj dữ liệu
      var vObject = readDataInModalUpdatemenu();  // đọc dữ liệu trên form modal sửa thông tin menu
      // b2 validate data
      console.log(vObject);
      var vResult = validateDataInsertmenu(vObject);  // dùng chung hàm với insert
      // b3 call server
      console.log("trước update: ", vObject);
      if (vResult) {
        updatemenuById(vObject, function (pamramRes) {
          // b4 hiển thị font end 
          console.log("server update: ", pamramRes);
          alert("thông báo đã cập nhật thành công");
          $("#update-menu-modal").modal("hide"); //tắt Modal 
          callApiListmenu(getInsertRowTable); //  load lại bảng danh sách menus
         
        });
      }
    }
    // nút xác nhận xóa menu 
    function onConfirmDeletemenuClick() {
      console.log("Xác nhận xóa ");
      // b3 gọi api để xóa menu theo iD 
      callApiDeletemenu(function () {
        // xử lý font end 
        alert("thông báo đã xóa menu thành công");
        $("#delete-confirm-modal").modal("hide"); //tắt Modal 
        callApiListmenu(getInsertRowTable); //  load lại bảng danh sách menus 
      });
    }
   
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    //            XỬ LÝ PHẦN ONPAGELOADING  
    // khởi tạo data table 
    function khoiTaoDataTable() {
      // khai báo mảng chứa giá trị các cột 
      const ARRAY_NAME_COL = ["stt", "size", "duongKinh",
        "suongNuong", "salad", "nuocNgot","donGia",  "action"];
      // định nghĩa số thứ tự cho các cột 
      const COL_STT = 0;
      const COL_SIZE = 1;
      const COL_DUONG_KINH = 2;
      const COL_SUON_NUONG = 3;
      const COL_SALAD = 4;
      const COL_NUOC_NGOT = 5;
      const COL_DON_GIA = 6;
      const COL_ACTION = 7;

      /* add JSON data vào DataTable sử dụng add trực tiếp DataTable row */
      $("#table-lich-su-hoc-tap").DataTable({
      
        columns: [
          { data: ARRAY_NAME_COL[COL_STT] },
          { data: ARRAY_NAME_COL[COL_SIZE] },
          { data: ARRAY_NAME_COL[COL_DUONG_KINH] },
          { data: ARRAY_NAME_COL[COL_SUON_NUONG] },
          { data: ARRAY_NAME_COL[COL_SALAD] },
          { data: ARRAY_NAME_COL[COL_NUOC_NGOT] },
          { data: ARRAY_NAME_COL[COL_DON_GIA] },
          { data: ARRAY_NAME_COL[COL_ACTION] },
        ],
        columnDefs: [

          {
            targets: COL_STT, // cột age  gListMonHoc  
            render: function () {
              gStt++;
              return gStt;
            }
          },

          {
            targets: COL_ACTION,
            defaultContent: '<i style="cursor: -webkit-grab; cursor: grab;" class="fa-solid fa-pencil   btn-edits" data-toggle="tooltip" data-placement="top" title="Sửa"></i>  &nbsp; &nbsp;' +
              '<i  style="cursor: -webkit-grab; cursor: grab;" class="fa-regular fa-trash-can btn-deletes" data-toggle="tooltip" data-placement="top" title="Xóa"></i>  &nbsp; &nbsp;',
              
          },
        ]
      });
    }
    //  gọi API load all menus      <i class="fa-regular fa-list-radio"></i>
    function callApiListmenu(pramFunction) {
      // khai báo ajax jquery
      $.ajax({
        url: gBASE_URL_MENU + "all",
        type: "GET",
        dataType: "json",
        success: pramFunction,
        error: function (paramError) {
          console.log("lỗi khi gọi api All menu" + paramError.status);
        }
      });
    }
    // hàm thêm từng dòng dữ liệu vào   // hàm này chính là success
    function getInsertRowTable(paramRes) {
      console.log("đã load đến insert table");
      var vTable = $("#table-lich-su-hoc-tap").DataTable();
      vTable.clear();// xóa trắng tbody trước khi load dữ liệu  
      vTable.rows.add(paramRes);
      vTable.draw();
      gStt = 0; // quy 0 số thứ tự
      // đổ dữ liệu table xongg đổ dữ liệu lên modal

    }
   


    // lấy tất cả giá trị của 1 hàng tương ứng với nút bấm trên hàng đó 
    function readObjectRow(paramThis) {
      console.log(paramThis);
      var vRowClick = $(paramThis).closest("tr"); // xác định hàng của nút ấn trên table  nut ấn 
      var vTable = $("#table-lich-su-hoc-tap").DataTable();   // tạo biến đến dataTable 
      var vDataRow = vTable.row(vRowClick);  // tìm hàng này trên data table trên data table 
      return vDataRow.data();
    }
    // ........................ [nút insert menu in modal].......................
    //04 bước xử lý sự kiện có gọi server
    // b1 thu thâpj dữ liệu và trả về object chứa thông tin menu 

    // "size": "HAKASDAJ",
    //     "duongKinh": "ảnh thợ săn",
    //     "suongNuong": null,
    //     "salad": "bacảnh thợ săn trên rừng núi hoang sơon",
    //     "ngayTao": "30-04-2023"
    //     "nuocNgot": 3


    function readDataModalInsertmenu() {
      var vObjectmenu = {
        size: "",
        duongKinh: "",
        suongNuong: "",
        salad: "",
        nuocNgot: "",
        donGia: ""
      }
      // gán giá trị cho đối tượng 
      vObjectmenu.size = $("#input-combo").val().trim();
      vObjectmenu.duongKinh = $("#input-size").val().trim();
      vObjectmenu.suongNuong = $("#input-suon").val().trim();
      vObjectmenu.salad = $("#input-salad").val().trim();
      vObjectmenu.nuocNgot = $("#input-drink").val().trim();  
      vObjectmenu.donGia = $("#input-price").val().trim();
      return vObjectmenu;
    }
    // b2 validate data
    // kiểm tra xem menu có nhập hay k . nếu không nhập thì nhắc nhở menu
    function validateDataInsertmenu(paramObject) {
      if (paramObject.size === "" ) {
        alert("combo phải được nhập ");
        return false;
      }
      if (paramObject.duongKinh === "" ) {
        alert("Đường kính phải được nhập và phải là số.");
        return false;
      }
      if (paramObject.suongNuong === "" ) {
        alert("Sườn nướng phải được nhập và phải là số.");
        return false;
      }
      if (paramObject.salad === "" ) {
        alert("Salad phải được nhập và phải là số.");
        return false;
      }
      if (paramObject.nuocNgot === "" ) {
        alert("Nước ngọt phải được nhập và phải là số.");
        return false;
      }
      if (paramObject.donGia === "" ) {
        alert("Đơn giá phải được nhập và phải là số.");
        return false;
      }
     

      return true;
    }

    // hàm xóa trắng form create menu
    function resertCreatemenuForm() {
      $("#input-combo").val("");
      $("#input-size").val("");
      $("#input-suon").val("");
      $("#input-salad").val("");
      $("#input-drink").val("");
      $("#input-price").val("");
    }
    // ......................[ xử lý nút edit . nút sửa ].....................
    // Mẫu gọi API Get menu by id
    function getDataByID(paramId, paramFunction) {
      $.ajax({
        url: gBASE_URL_MENU  + paramId,
        type: "GET",
        dataType: "json",
        //async: false,
        success: paramFunction,
        error: function (paramError) {
          console.log(paramError.status)
        },
      });
    }

     //xóa trắng  dữ liệu lên fomr modal update
     function xoaTrangUpdateMenu(paramObject) {
      // đổi từ id 
      console.log("đã xóa trắng dữ liệu từ update menu");
      $("#input-combo-update").val("");
      $("#input-size-update").val("");
      $("#input-suon-update").val("");
      $("#input-salad-update").val("");  //
      $("#input-drink-update").val("");
      $("#input-price-update").val("");
      

    }


    //load load dữ liệu lên fomr modal update
    function loadDataInModalUpdatemenu(paramObject) {
      // đổi từ id 
      $("#input-combo-update").val(paramObject.size);
      $("#input-size-update").val(paramObject.suongNuong);
      $("#input-suon-update").val(paramObject.duongKinh);
      $("#input-salad-update").val(paramObject.salad);  //
      $("#input-drink-update").val(paramObject.nuocNgot);
      $("#input-price-update").val(paramObject.donGia);
      console.log("load xong  data update");

    }
    // ..................................[Nút update menu (sửa thông tin menu)].............
    //04 bước xử lý sự kiện có gọi server
    // b1 thu thâpj dữ liệu
    function readDataInModalUpdatemenu() {
      var vObjectmenu = {
        size: "",
        duongKinh: "",
        suongNuong: "",
        salad: "",
        nuocNgot: "",
        donGia: ""
      }
      // gán giá trị cho đối tượng 
      vObjectmenu.size = $("#input-combo-update").val().trim();
      vObjectmenu.duongKinh = $("#input-size-update").val().trim();
      vObjectmenu.suongNuong = $("#input-suon-update").val().trim();
      vObjectmenu.salad = $("#input-salad-update").val().trim();
      vObjectmenu.nuocNgot = $("#input-drink-update").val().trim();  
      vObjectmenu.donGia = $("#input-price-update").val().trim();
      return vObjectmenu;
    }
   

    // b3 call server
    //  gọi API Update menu by Id
    function updatemenuById(paramObject, paramFunction) {
      $.ajax({
        url: gBASE_URL_MENU + "update/" + gId,
        type: "PUT",
        contentType: "application/json;charset=UTF-8",
        data: JSON.stringify(paramObject),
        success: paramFunction,
        error: function (paramError) {
          console.log(paramError.status);
          console.log(paramError);
          if(paramError.status == 422){
            alert("không thể tạo ra 2 combo có tên giống nhau");
          }
          alert("cập nhập (không) thành công");


        }
      });
    }
    // ................... [nút xác nhận xóa menu]............
    function callApiDeletemenu(paramFunciton) {
      $.ajax({
        url: gBASE_URL_MENU + "/delete/" + gId,
        type: "DELETE",
        // dataType: "json",
        success: paramFunciton,
        error: function (paramError) {
          console.log(paramError.status);
          alert("Hệ thống chưa thể xóa menu do trục trặc kỹ thuật  " + paramError.status);
          $("#delete-confirm-modal").modal("hide"); //tắt Modal 
        },
      });
    }

   


  
 

  </script>
</body>

</html>